<?

/*
  $Id$

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2003 osCommerce

  Released under the GNU General Public License
*/

  class paynet {
    var $code, $title, $description, $enabled;

// class constructor
    function paynet() {
      global $order;

      $this->code = 'paynet';
      $this->title = MODULE_PAYMENT_PAYNET_TEXT_TITLE;
      $this->description = MODULE_PAYMENT_PAYNET_TEXT_DESCRIPTION;
      $this->sort_order = MODULE_PAYMENT_PAYNET_SORT_ORDER;
      $this->enabled = ((MODULE_PAYMENT_PAYNET_STATUS == 'True') ? true : false);

	  $this->public_title = MODULE_PAYMENT_PAYNET_TEXT_PUBLIC_TITLE;


      if ((int)MODULE_PAYMENT_PAYNET_ORDER_STATUS_ID > 0) {
        $this->order_status = MODULE_PAYMENT_PAYNET_ORDER_STATUS_ID;
      }
	  

      //if (is_object($order)) $this->update_status();


$this->state_list = array('ALABAMA'=>"AL",
'ALASKA'=>"AK",
'AMERICAN SAMOA'=>"AS",
'ARIZONA'=>"AZ",
'ARKANSAS'=>"AR",
'CALIFORNIA'=>"CA",
'COLORADO'=>"CO",
'CONNECTICUT'=>"CT",
'DELAWARE'=>"DE",
'DISTRICT OF COLUMBIA'=>"DC",
"FEDERATED STATES OF MICRONESIA"=>"FM",
'FLORIDA'=>"FL",
'GEORGIA'=>"GA",
'GUAM' => "GU",
'HAWAII'=>"HI",
'IDAHO'=>"ID",
'ILLINOIS'=>"IL",
'INDIANA'=>"IN",
'IOWA'=>"IA",
'KANSAS'=>"KS",
'KENTUCKY'=>"KY",
'LOUISIANA'=>"LA",
'MAINE'=>"ME",
'MARSHALL ISLANDS'=>"MH",
'MARYLAND'=>"MD",
'MASSACHUSETTS'=>"MA",
'MICHIGAN'=>"MI",
'MINNESOTA'=>"MN",
'MISSISSIPPI'=>"MS",
'MISSOURI'=>"MO",
'MONTANA'=>"MT",
'NEBRASKA'=>"NE",
'NEVADA'=>"NV",
'NEW HAMPSHIRE'=>"NH",
'NEW JERSEY'=>"NJ",
'NEW MEXICO'=>"NM",
'NEW YORK'=>"NY",
'NORTH CAROLINA'=>"NC",
'NORTH DAKOTA'=>"ND",
"NORTHERN MARIANA ISLANDS"=>"MP",
'OHIO'=>"OH",
'OKLAHOMA'=>"OK",
'OREGON'=>"OR",
"PALAU"=>"PW",
'PENNSYLVANIA'=>"PA",
'RHODE ISLAND'=>"RI",
'SOUTH CAROLINA'=>"SC",
'SOUTH DAKOTA'=>"SD",
'TENNESSEE'=>"TN",
'TEXAS'=>"TX",
'UTAH'=>"UT",
'VERMONT'=>"VT",
'VIRGIN ISLANDS' => "VI",
'VIRGINIA'=>"VA",
'WASHINGTON'=>"WA",
'WEST VIRGINIA'=>"WV",
'WISCONSIN'=>"WI",
'WYOMING'=>"WY");

	  
    }

// class methods
    function update_status() {
      global $order;
	  /*
		Here you can implement using payment zones (refer to standard PayPal module as reference).
		Called by module's class constructor, checkout_confirmation.php, checkout_process.php
	  */
/*
      if ( ($this->enabled == true) && ((int)MODULE_PAYMENT_PAYNET_ZONE > 0) ) {
        $check_flag = false;
        $check_query = tep_db_query("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_PAYMENT_PAYNET_ZONE . "' and zone_country_id = '" . $order->billing['country']['id'] . "' order by zone_id");
        while ($check = tep_db_fetch_array($check_query)) {
          if ($check['zone_id'] < 1) {
            $check_flag = true;
            break;
          } elseif ($check['zone_id'] == $order->billing['zone_id']) {
            $check_flag = true;
            break;
          }
        }

        if ($check_flag == false) {
          $this->enabled = false;
        }
      }
	  */
    }

    function javascript_validation() {
		/*
		Here you may define client side javascript that will verify any input fields you use in the payment method selection page. Refer to standard cc module as reference (cc.php).
		Called by checkout_payment.php
		*/
      return false;
    }

    function selection() {
		/*  outputs the payment method title and if required, the input fields. Called by checkout_payment.php */
      return array('id' => $this->code, 'module' => $this->public_title);
    }

    function pre_confirmation_check() {
		/*     

		Use this function implement any checks of any conditions after payment method has been selected. 
		You most probably don't need to implement anything here.
		Called by checkout_confirmation.php before any page output.
		*/
      return false;
    }

    function confirmation() {

      global $order;

      for ($i=1; $i<13; $i++) {
        $expires_month[] = array('id' => sprintf('%02d', $i), 'text' => strftime('%B',mktime(0,0,0,$i,1,2000)));
      }

      $today = getdate(); 
      for ($i=$today['year']; $i < $today['year']+10; $i++) {
        $expires_year[] = array('id' => strftime('%y',mktime(0,0,0,1,1,$i)), 'text' => strftime('%Y',mktime(0,0,0,1,1,$i)));
      }

      $confirmation = array('fields' => array(array('title' => MODULE_PAYMENT_PAYNET_CREDIT_CARD_OWNER,
                                                    'field' => tep_draw_input_field('cc_owner', $order->billing['firstname'] . ' ' . $order->billing['lastname'])),
                                              array('title' => MODULE_PAYMENT_PAYNET_CREDIT_CARD_NUMBER,
                                                    'field' => tep_draw_input_field('cc_number_nh-dns')),
                                              array('title' => MODULE_PAYMENT_PAYNET_CREDIT_CARD_EXPIRES,
                                                    'field' => tep_draw_pull_down_menu('cc_expires_month', $expires_month) . '&nbsp;' . tep_draw_pull_down_menu('cc_expires_year', $expires_year)),
                                              array('title' => MODULE_PAYMENT_PAYNET_CREDIT_CARD_CVC,
                                                    'field' => tep_draw_input_field('cc_cvc_nh-dns', '', 'size="5" maxlength="4"'))));

      return $confirmation;
    }

    function process_button() {
		/* Outputs the html form hidden elements sent as POST data to the payment gateway. Called by checkout_confirmation.php */
	  return false;
    }

    function before_process() {
		/* This is where you will implement any payment verification. This function can be quite complicated to implement. 
		Called by checkout_process.php before order is finalised  */
		 
		global $_POST, $customer_id, $order, $sendto, $currency;


		$state_tmp = $order->billing['state'];
		if(substr($order->billing['country']['iso_code_2'], 0, 60) == 'US') $state_tmp = $this->state_list[strtoupper($order->billing['state'])];

		$amount_tmp = $this->format_raw($order->info['total']);

		$check_query = tep_db_query("select orders_id from " . TABLE_ORDERS . " where customers_id = '" . (int)$customer_id . "' order by date_purchased desc limit 1");
		//tep_db_num_rows($check_query))
		$check = tep_db_fetch_array($check_query);
		$order_id = $check['orders_id'];

		$control = sha1(MODULE_PAYMENT_PAYNET_NON3D_SID . $order_id . $_POST['cc_number_nh-dns'] . $amount_tmp*100 . $order->customer['email_address'] . MODULE_PAYMENT_PAYNET_CHECKSUM) ;



	$order_desc = '';
	$products_ordered = '';
	for ($i=0, $n=sizeof($order->products); $i<$n; $i++) {
		$products_ordered .= $order->products[$i]['qty'] . ' x ' . $order->products[$i]['name'] . ' (' . $order->products[$i]['model'] . ') ' ;// . $currencies->display_price($order->products[$i]['final_price'], $order->products[$i]['tax'], $order->products[$i]['qty'])
        $products_ordered_attributes = '';
        if (isset($order->products[$i]['attributes'])) {
          for ($j=0, $n2=sizeof($order->products[$i]['attributes']); $j<$n2; $j++) {
            $attributes = tep_db_query("select popt.products_options_name, poval.products_options_values_name, pa.options_values_price, pa.price_prefix from " . TABLE_PRODUCTS_OPTIONS . " popt, " . TABLE_PRODUCTS_OPTIONS_VALUES . " poval, " . TABLE_PRODUCTS_ATTRIBUTES . " pa where pa.products_id = '" . $order->products[$i]['id'] . "' and pa.options_id = '" . $order->products[$i]['attributes'][$j]['option_id'] . "' and pa.options_id = popt.products_options_id and pa.options_values_id = '" . $order->products[$i]['attributes'][$j]['value_id'] . "' and pa.options_values_id = poval.products_options_values_id and popt.language_id = '" . $languages_id . "' and poval.language_id = '" . $languages_id . "'");
            $attributes_values = tep_db_fetch_array($attributes);
            $products_ordered_attributes .= "\n\t" . $attributes_values['products_options_name'] . ' ' . $attributes_values['products_options_values_name']. ' ';
          }
        }
		$products_ordered .= ' '.$products_ordered_attributes;
	}



	
	$order_desc = $products_ordered;
	$order_desc = str_replace("\n", "", $order_desc);
	$order_desc = str_replace("\t", "", $order_desc);



      $params = array('version' => 1,
		  'sid' => MODULE_PAYMENT_PAYNET_NON3D_SID,
		  'client_orderid' => $order_id,
		  'order_desc' => $order_desc,
		  'first_name' => substr($order->billing['firstname'], 0, 50),
		  'last_name' => substr($order->billing['lastname'], 0, 50),
		  'address1' => substr($order->billing['street_address'], 0, 60),
		  'city' => substr($order->billing['city'], 0, 40),		  
		  'state' => $state_tmp,
		  'zip_code' => substr($order->billing['postcode'], 0, 20),
		  'country' => substr($order->billing['country']['iso_code_2'], 0, 60),
		  'phone' => substr($order->customer['telephone'], 0, 25),
		  'email' => substr($order->customer['email_address'], 0, 255),
		  'amount' => substr($this->format_raw($order->info['total']), 0, 15),
		  'currency' => substr($currency, 0, 3),
		  'credit_card_number' => substr($_POST['cc_number_nh-dns'], 0, 22),
		  'expire_month' => $_POST['cc_expires_month'],
		  'expire_year' => $_POST['cc_expires_year'],
		  'cvv2' => substr($_POST['cc_cvc_nh-dns'], 0, 4),
		  'ipaddress' => tep_get_ip_address(),
		  'control' => substr($control, 0, 40)
		  /*, 'site_url' => '',
	  $_SERVER['REMOTE_ADDR']
		  */

			    );

	  /*
        
                      'x_company' => substr($order->billing['company'], 0, 50),
                      'x_cust_id' => substr($customer_id, 0, 20),
                      'x_description' => substr(STORE_NAME, 0, 255),
                      'x_type' => ((MODULE_PAYMENT_AUTHORIZENET_CC_AIM_TRANSACTION_METHOD == 'Capture') ? 'AUTH_CAPTURE' : 'AUTH_ONLY'),

		*/


      foreach ($params as $key => $value) {
        $post_string .= $key . '=' . urlencode(trim($value)) . '&';
      }

  	 $post_string = substr($post_string, 0, -1);

	 $gateway_url = MODULE_PAYMENT_PAYNET_ACTIONURL_ORDER;//'http://softm-pay.biz/sm/payment.html';

	 $transaction_response = $this->sendTransactionToGateway($gateway_url, $post_string);



//status=approved&error_message=&error_code=&orderid=S171G3P1T2224534&merchant_order=1233&client_orderid=1233&descriptor=&txdate=2011-03-20 16:22:2311
	$response_a = explode('&', $transaction_response);
	
	foreach($response_a as $rp) {
		$rp_a = explode("=", $rp);
		$payment_response[$rp_a[0]]=$rp_a[1];
	}

	if($payment_response['status'] == 'declined') {
        tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, 'payment_error=' . $this->code . '&error=' . urlencode($payment_response['error_message']), 'NONSSL'));
	}

      return false;
    }

    function after_process() {
		/* Here you may implement any post proessing of the payment/order after the order has been finalised. At this point you now have a reference to the created osCommerce order id and you would typically update any custom database tables you may have for your module. You most probably don't need to implement anything here.
		Called by checkout_process.php after order is finalised */
      return false;
    }


	function get_error() {
      global $_GET;

      $error_message = MODULE_PAYMENT_PAYNET_ERROR_GENERAL;//$_GET['error']; //;


      $error = array('title' => MODULE_PAYMENT_PAYNET_ERROR_TITLE,
                     'error' => $error_message);

      return $error;
    }


    function output_error() {
      return false;
    }

    function check() {
		/* Standard functionlity for osCommerce to see if the module is installed. */
      if (!isset($this->_check)) {
        $check_query = tep_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_PAYNET_STATUS'");
        $this->_check = tep_db_num_rows($check_query);
      }
      return $this->_check;
    }

    function install() {
		/* This is where you define module's configurations (displayed in admin). */
      
	  tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort order of display.', 'MODULE_PAYMENT_PAYNET_SORT_ORDER', '0', 'Sort order of display. Lowest is displayed first.', '6', '0', now())");
	  
	  tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable Paynet Module', 'MODULE_PAYMENT_PAYNET_STATUS', 'True', 'Do you want to accept PAYNET payments?', '6', '3', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");

	  tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Website SID', 'MODULE_PAYMENT_PAYNET_NON3D_SID', '111', 'sid', '6', '0', now())");

	  tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Control', 'MODULE_PAYMENT_PAYNET_CHECKSUM', '5b1da0a20a1b9f350f4d66caaba15a9533e7ee13', 'control checksum', '6', '0', now())");

	  tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('URL', 'MODULE_PAYMENT_PAYNET_ACTIONURL_ORDER', '', 'Action URL', '6', '0', now())");
	  

	  
		/*
      
      
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Payment Zone', 'MODULE_PAYMENT_PAYNET_ZONE', '0', 'If a zone is selected, only enable this payment method for that zone.', '6', '2', 'tep_get_zone_class_title', 'tep_cfg_pull_down_zone_classes(', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('Set Order Status', 'MODULE_PAYMENT_PAYNET_ORDER_STATUS_ID', '0', 'Set the status of orders made with this payment module to this value', '6', '0', 'tep_cfg_pull_down_order_statuses(', 'tep_get_order_status_name', now())");
	  */
    }

    function remove() {
      tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

    function keys() {
		/* This array must include all the configuration setting keys defined in your install() function. */

		return array('MODULE_PAYMENT_PAYNET_STATUS', 'MODULE_PAYMENT_PAYNET_SORT_ORDER', 'MODULE_PAYMENT_PAYNET_NON3D_SID', 'MODULE_PAYMENT_PAYNET_CHECKSUM', 'MODULE_PAYMENT_PAYNET_ACTIONURL_ORDER');
      //return array('', 'MODULE_PAYMENT_PAYNET_ID', 'MODULE_PAYMENT_PAYNET_ZONE', 'MODULE_PAYMENT_PAYNET_ORDER_STATUS_ID', '');
    }


	function sendTransactionToGateway($url, $parameters) {
      $server = parse_url($url);

      if (isset($server['port']) === false) {
        $server['port'] = ($server['scheme'] == 'https') ? 443 : 80;
      }

      if (isset($server['path']) === false) {
        $server['path'] = '/';
      }

      if (isset($server['user']) && isset($server['pass'])) {
        $header[] = 'Authorization: Basic ' . base64_encode($server['user'] . ':' . $server['pass']);
      }

      if (function_exists('curl_init')) {
        $curl = curl_init($server['scheme'] . '://' . $server['host'] . $server['path'] . (isset($server['query']) ? '?' . $server['query'] : ''));
        curl_setopt($curl, CURLOPT_PORT, $server['port']);
        curl_setopt($curl, CURLOPT_HEADER, 0);
        curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, 0);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($curl, CURLOPT_FORBID_REUSE, 1);
        curl_setopt($curl, CURLOPT_FRESH_CONNECT, 1);
        curl_setopt($curl, CURLOPT_POST, 1);
        curl_setopt($curl, CURLOPT_POSTFIELDS, $parameters);

        $result = curl_exec($curl);

        curl_close($curl);
      } else {
        /*
		exec(escapeshellarg(MODULE_PAYMENT_AUTHORIZENET_CC_AIM_CURL) . ' -d ' . escapeshellarg($parameters) . ' "' . $server['scheme'] . '://' . $server['host'] . $server['path'] . (isset($server['query']) ? '?' . $server['query'] : '') . '" -P ' . $server['port'] . ' -k', $result);
        $result = implode("\n", $result);
		*/
      }

      return $result;
    }

    function format_raw($number, $currency_code = '', $currency_value = '') {
      global $currencies, $currency;

      if (empty($currency_code) || !$this->is_set($currency_code)) {
        $currency_code = $currency;
      }

      if (empty($currency_value) || !is_numeric($currency_value)) {
        $currency_value = $currencies->currencies[$currency_code]['value'];
      }

      return number_format(tep_round($number * $currency_value, $currencies->currencies[$currency_code]['decimal_places']), $currencies->currencies[$currency_code]['decimal_places'], '.', '');
    }




  }


?>